diff -Naur ruby-1.9.3-p547.original/lib/webrick/utils.rb ruby-1.9.3-p547.htm/lib/webrick/utils.rb
--- ruby-1.9.3-p547.original/lib/webrick/utils.rb	2012-05-19 14:40:29.000000000 +0900
+++ ruby-1.9.3-p547.htm/lib/webrick/utils.rb	2014-09-12 06:37:35.905002000 +0900
@@ -175,12 +175,14 @@
         Thread.start{
           while true
             now = Time.now
+            TimeoutMutex.synchronie {
             @timeout_info.each{|thread, ary|
               ary.dup.each{|info|
                 time, exception = *info
                 interrupt(thread, info.object_id, exception) if time < now
               }
             }
+            }
             sleep 0.5
           end
         }
diff -Naur ruby-1.9.3-p547.original/ruby.c ruby-1.9.3-p547.htm/ruby.c
--- ruby-1.9.3-p547.original/ruby.c	2012-10-16 11:11:36.000000000 +0900
+++ ruby-1.9.3-p547.htm/ruby.c	2014-09-16 01:11:39.012549000 +0900
@@ -8,6 +8,7 @@
   Copyright (C) 1993-2007 Yukihiro Matsumoto
   Copyright (C) 2000  Network Applied Communication Laboratory, Inc.
   Copyright (C) 2000  Information-technology Promotion Agency, Japan
+  Copyright (c) IBM Corp. 2014.
 
 **********************************************************************/
 
@@ -23,6 +24,9 @@
 #include <stdio.h>
 #include <sys/types.h>
 #include <ctype.h>
+#ifdef HTM_GVL
+#include <string.h>
+#endif
 
 #ifdef __hpux
 #include <sys/pstat.h>
@@ -57,6 +61,9 @@
     disable_gems,
     disable_rubyopt,
     disable_flag_count
+#ifdef HTM_GVL
+    ,disable_htm
+#endif
 };
 
 #define DUMP_BIT(bit) (1U << dump_##bit)
@@ -662,6 +669,9 @@
 #define SET_WHEN_DISABLE(bit) SET_WHEN(#bit, DISABLE_BIT(bit), str, len)
     SET_WHEN_DISABLE(gems);
     SET_WHEN_DISABLE(rubyopt);
+#ifdef HTM_GVL
+    SET_WHEN_DISABLE(htm);
+#endif
     if (NAME_MATCH_P("all", str, len)) {
 	*(unsigned int *)arg = ~0U;
 	return;
@@ -1376,6 +1386,17 @@
 	rb_define_module("Gem");
 #endif
     }
+#ifdef HTM_GVL
+    if (opt->disable & DISABLE_BIT(htm)) {
+	ruby_use_gvl = 1;
+    }
+    {
+	char *ruby_disable_htm = getenv("RUBY_DISABLE_HTM");
+	if (ruby_disable_htm && strcmp(ruby_disable_htm, "yes") == 0) {
+	    ruby_use_gvl = 1;
+	}
+    }
+#endif
     ruby_init_prelude();
     ruby_set_argv(argc, argv);
     process_sflag(&opt->sflag);
diff -Naur ruby-1.9.3-p547.original/thread.c ruby-1.9.3-p547.htm/thread.c
--- ruby-1.9.3-p547.original/thread.c	2014-02-17 18:09:32.000000000 +0900
+++ ruby-1.9.3-p547.htm/thread.c	2014-09-12 06:37:35.905002000 +0900
@@ -5,6 +5,7 @@
   $Author: usa $
 
   Copyright (C) 2004-2007 Koichi Sasada
+  Copyright (c) IBM Corp. 2014.
 
 **********************************************************************/
 
@@ -110,22 +111,87 @@
 
 static inline void blocking_region_end(rb_thread_t *th, struct rb_blocking_region_buffer *region);
 
+#ifdef HTM_GVL
+/* Store-to-store barrier is needed. */
+#if defined(__370__)
 #define RB_GC_SAVE_MACHINE_CONTEXT(th) \
   do { \
     rb_gc_save_machine_context(th); \
     SET_MACHINE_STACK_END(&(th)->machine_stack_end); \
+    th->gc_safe_point_reached = 1; \
   } while (0)
+#elif defined(__PPC__) && defined(__IBMC__)
+#define RB_GC_SAVE_MACHINE_CONTEXT(th) \
+  do { \
+    rb_gc_save_machine_context(th); \
+    SET_MACHINE_STACK_END(&(th)->machine_stack_end); \
+    __lwsync(); \
+    th->gc_safe_point_reached = 1; \
+  } while (0)
+#elif defined(__PPC__) || defined(_ARCH_PPC)
+#define RB_GC_SAVE_MACHINE_CONTEXT(th) \
+  do { \
+    rb_gc_save_machine_context(th); \
+    SET_MACHINE_STACK_END(&(th)->machine_stack_end); \
+    asm volatile("lwsync" : : ); \
+    th->gc_safe_point_reached = 1; \
+  } while (0)
+#elif defined(__GNUC__) || defined(__IBMC__)
+#define RB_GC_SAVE_MACHINE_CONTEXT(th) \
+  do { \
+    rb_gc_save_machine_context(th); \
+    SET_MACHINE_STACK_END(&(th)->machine_stack_end); \
+    __sync_synchronize(); \
+    th->gc_safe_point_reached = 1; \
+  } while (0)
+#else
+#error
+#endif
+#else /* ! HTM_GVL */
+#define RB_GC_SAVE_MACHINE_CONTEXT(th) \
+  do { \
+    rb_gc_save_machine_context(th); \
+    SET_MACHINE_STACK_END(&(th)->machine_stack_end); \
+  } while (0)
+#endif /* ! HTM_GVL */
 
+#ifdef HTM_GVL
+#define GVL_UNLOCK_BEGIN() do { \
+  rb_thread_t *_th_stored = GET_THREAD(); \
+  RB_GC_SAVE_MACHINE_CONTEXT(_th_stored); \
+  gvl_release(_th_stored->vm, _th_stored);
+#else
 #define GVL_UNLOCK_BEGIN() do { \
   rb_thread_t *_th_stored = GET_THREAD(); \
   RB_GC_SAVE_MACHINE_CONTEXT(_th_stored); \
   gvl_release(_th_stored->vm);
+#endif
 
+#ifdef HTM_GVL
 #define GVL_UNLOCK_END() \
+  th->gc_safe_point_reached = 0; \
   gvl_acquire(_th_stored->vm, _th_stored); \
   rb_thread_set_current(_th_stored); \
 } while(0)
+#else
+#define GVL_UNLOCK_END() \
+  gvl_acquire(_th_stored->vm, _th_stored); \
+  rb_thread_set_current(_th_stored); \
+} while(0)
+#endif
 
+#ifdef HTM_GVL
+#define blocking_region_begin(th, region, func, arg) \
+  do { \
+    (region)->prev_status = (th)->status; \
+    set_unblock_function((th), (func), (arg), &(region)->oldubf); \
+    (th)->blocking_region_buffer = (region); \
+    (th)->status = THREAD_STOPPED; \
+    thread_debug("enter blocking region (%p)\n", (void *)(th)); \
+    RB_GC_SAVE_MACHINE_CONTEXT(th); \
+    gvl_release((th)->vm, (th));    \
+  } while (0)
+#else
 #define blocking_region_begin(th, region, func, arg) \
   do { \
     (region)->prev_status = (th)->status; \
@@ -136,6 +202,7 @@
     RB_GC_SAVE_MACHINE_CONTEXT(th); \
     gvl_release((th)->vm); \
   } while (0)
+#endif
 
 #define BLOCKING_REGION(exec, ubf, ubfarg) do { \
     rb_thread_t *__th = GET_THREAD(); \
@@ -258,7 +325,11 @@
 void
 rb_vm_gvl_destroy(rb_vm_t *vm)
 {
+#ifdef HTM_GVL
+    gvl_release(vm, GET_THREAD());
+#else
     gvl_release(vm);
+#endif
     gvl_destroy(vm);
 }
 
@@ -407,6 +478,63 @@
 #endif
 }
 
+#ifdef HTM_GVL
+#ifdef HTM_GVL_SUMMARY_STATS
+void
+accumulate_thr_htm_stats(rb_thread_t *th)
+{
+#if defined(__370__)
+    int i, j;
+#endif
+
+    th->vm->htm_stats.tx += th->htm_stats.tx;
+    th->vm->htm_stats.tx_enter += th->htm_stats.tx_enter;
+    th->vm->htm_stats.abort += th->htm_stats.abort;
+    th->vm->htm_stats.first_abort += th->htm_stats.first_abort;
+    th->vm->htm_stats.gvl_wait_before_tx_spin += th->htm_stats.gvl_wait_before_tx_spin;
+    th->vm->htm_stats.gvl_wait_before_tx_sleep += th->htm_stats.gvl_wait_before_tx_sleep;
+    th->vm->htm_stats.gvl_wait_and_retry_spin += th->htm_stats.gvl_wait_and_retry_spin;
+    th->vm->htm_stats.gvl_wait_and_retry_sleep += th->htm_stats.gvl_wait_and_retry_sleep;
+    th->vm->htm_stats.gvl_acquired += th->htm_stats.gvl_acquired;
+    th->vm->htm_stats.persistent_abort_retry += th->htm_stats.persistent_abort_retry;
+    th->vm->htm_stats.gvl_persistent_abort += th->htm_stats.gvl_persistent_abort;
+    th->vm->htm_stats.transient_abort_retry += th->htm_stats.transient_abort_retry;
+    th->vm->htm_stats.gvl_transient_abort += th->htm_stats.gvl_transient_abort;
+#if defined(__370__)
+    for (i = 0; i < 19; i++) {
+	for (j = 0; j < 3; j++) {
+	    th->vm->htm_stats.abort_reason_code[i][j] += th->htm_stats.abort_reason_code[i][j];
+	}
+    }
+#elif defined(__x86_64__)
+#define HTM_IA32_STAT(nam) th->vm->htm_stats.abort_reason_counters.nam += th->htm_stats.abort_reason_counters.nam;
+#include "htm_ia32_stat.h"
+#undef HTM_IA32_STAT
+#elif defined(__PPC__) || defined(_ARCH_PPC)
+#define HTM_PPC_STAT(nam) th->vm->htm_stats.abort_reason_counters.nam += th->htm_stats.abort_reason_counters.nam;
+#include "htm_ppc_stat.h"
+#undef HTM_PPC_STAT
+#else
+#error
+#endif
+}
+#endif
+#ifdef HTM_GVL_CYCLE_STATS
+void
+accumulate_thr_htm_cycle_stats(rb_thread_t *th)
+{
+    th->vm->cycle_stats.tx += th->cycle_stats.tx;
+    th->vm->cycle_stats.abort += th->cycle_stats.abort;
+    th->vm->cycle_stats.gvl_wait_spin += th->cycle_stats.gvl_wait_spin;
+    th->vm->cycle_stats.gvl_wait_sleep += th->cycle_stats.gvl_wait_sleep;
+    th->vm->cycle_stats.gvl += th->cycle_stats.gvl;
+    th->vm->cycle_stats.between_tx += th->cycle_stats.between_tx;
+    th->vm->cycle_stats.mutex_sleep += th->cycle_stats.mutex_sleep;
+    th->vm->cycle_stats.native_sleep += th->cycle_stats.native_sleep;
+}
+#endif
+#endif /* HTM_GVL */
+
 static void
 thread_cleanup_func(void *th_ptr, int atfork)
 {
@@ -425,6 +553,14 @@
 
     native_mutex_destroy(&th->interrupt_lock);
     native_thread_destroy(th);
+#ifdef HTM_GVL
+#ifdef HTM_GVL_SUMMARY_STATS
+    accumulate_thr_htm_stats(th);
+#endif
+#ifdef HTM_GVL_CYCLE_STATS
+    accumulate_thr_htm_cycle_stats(th);
+#endif
+#endif
 }
 
 static VALUE rb_threadptr_raise(rb_thread_t *, int, VALUE *);
@@ -552,7 +688,11 @@
     }
     else {
 	thread_cleanup_func(th, FALSE);
+#ifdef HTM_GVL
+	gvl_release(th->vm, th);
+#else
 	gvl_release(th->vm);
+#endif
     }
 
     return 0;
@@ -1054,11 +1194,28 @@
     }
 }
 
+#ifdef HTM_GVL
+int
+rb_thread_alone_fast(void *ptr)
+{
+    rb_thread_t *th = (rb_thread_t *)ptr;
+    int num = 1;
+    if (th->vm->living_threads) {
+	num = th->vm->living_threads->num_entries;
+	thread_debug("rb_thread_alone: %d\n", num);
+    }
+    return num == 1;
+}
+#endif /* HTM_GVL */
+
 /* blocking region */
 
 static inline void
 blocking_region_end(rb_thread_t *th, struct rb_blocking_region_buffer *region)
 {
+#ifdef HTM_GVL
+    th->gc_safe_point_reached = 0;
+#endif
     gvl_acquire(th->vm, th);
     rb_thread_set_current(th);
     thread_debug("leave blocking region (%p)\n", (void *)th);
@@ -3026,7 +3183,13 @@
     rb_vm_t *vm = GET_VM(); /* TODO: fix me for Multi-VM */
 
     /* for time slice */
+#if RUBY_VM_THREAD_MODEL == 3
+    if (vm->use_gvl) {
+	RUBY_VM_SET_TIMER_INTERRUPT(vm->running_thread);
+    }
+#else
     RUBY_VM_SET_TIMER_INTERRUPT(vm->running_thread);
+#endif
 
     /* check signal */
     rb_threadptr_check_signal(vm->main_thread);
@@ -3093,6 +3256,11 @@
     rb_thread_t *th = GET_THREAD();
     rb_vm_t *vm = th->vm;
     VALUE thval = th->self;
+#ifdef ALIGN_RB_THREAD_T
+    void *th_before_aligned;
+    TypedData_Get_Struct(thval, rb_thread_t, &ruby_threadptr_data_type, th_before_aligned);
+    vm->main_thread_before_aligned = th_before_aligned;
+#endif
     vm->main_thread = th;
 
     gvl_atfork(th->vm);
@@ -3513,6 +3681,7 @@
 	    break;
 	}
 
+	HTM_GVL_CHARGE_CYCLES_TO_SAVED_TARGET();
 	if (timeout_ms) {
 	    struct timespec timeout_rel;
 	    struct timespec timeout;
@@ -3526,6 +3695,7 @@
 	    native_cond_wait(&mutex->cond, &mutex->lock);
 	    err = 0;
 	}
+	HTM_GVL_CHARGE_CYCLES_TO_AND_START(mutex_sleep, between_tx);
     }
     mutex->cond_waiting--;
 
@@ -4774,6 +4944,7 @@
 	{
 	    /* acquire global vm lock */
 	    gvl_init(th->vm);
+	    HTM_GVL_START_CYCLES();
 	    gvl_acquire(th->vm, th);
 	    native_mutex_initialize(&th->interrupt_lock);
 	}
diff -Naur ruby-1.9.3-p547.original/thread_pthread.c ruby-1.9.3-p547.htm/thread_pthread.c
--- ruby-1.9.3-p547.original/thread_pthread.c	2014-02-14 15:06:14.000000000 +0900
+++ ruby-1.9.3-p547.htm/thread_pthread.c	2014-09-12 06:37:35.905002000 +0900
@@ -6,6 +6,7 @@
   $Author: usa $
 
   Copyright (C) 2004-2007 Koichi Sasada
+  Copyright (c) IBM Corp. 2014.
 
 **********************************************************************/
 
@@ -27,6 +28,9 @@
 #if defined(HAVE_SYS_TIME_H)
 #include <sys/time.h>
 #endif
+#if defined(HTM_GVL)
+#include <math.h>
+#endif
 
 static void native_mutex_lock(pthread_mutex_t *lock);
 static void native_mutex_unlock(pthread_mutex_t *lock);
@@ -75,12 +79,390 @@
     vm->gvl.acquired = 1;
 }
 
+static inline void
+store_to_load_fence(void) {
+#if defined(__370__)
+    /* Nothing to do */
+#elif defined(__PPC__) && defined(__IBMC__)
+    __sync();
+#elif defined(__PPC__) || defined(_ARCH_PPC)
+    asm volatile("sync" : : );
+#elif defined(__GNUC__) || defined(__IBMC__)
+    __sync_synchronize();
+#else
+#error
+#endif
+}
+
+static inline void
+store_to_store_fence(void) {
+#if defined(__370__)
+    /* Nothing to do */
+#elif defined(__PPC__) && defined(__IBMC__)
+    __lwsync();
+#elif defined(__PPC__) || defined(_ARCH_PPC)
+    asm volatile("lwsync" : : );
+#elif defined(__GNUC__) || defined(__IBMC__)
+    __sync_synchronize();
+#else
+#error
+#endif
+}
+
+#ifdef USE_SIMPLE_GVL_2
+static int
+htm_fall_back_gvl_acquire(rb_vm_t *vm, rb_thread_t *th, int acquire)
+{
+    int spin_count = rb_gvl_spin_max;
+#ifdef __370__
+    unsigned long local_acquired;
+    unsigned long new_value = (unsigned long)th;
+#endif
+#ifdef HTM_GVL
+    RB_GC_SAVE_MACHINE_CONTEXT(th);
+#endif
+
+    /*fprintf(stderr, "thr %p start spinning on vm->gvl.waiting\n", th);*/
+    HTM_GVL_CHARGE_CYCLES_TO_SAVED_TARGET();
+    while (vm->gvl.acquired && --spin_count > 0)
+	;
+    if (! acquire && ! vm->gvl.acquired) {
+	HTM_GVL_CHARGE_CYCLES_TO(gvl_wait_spin);
+#ifdef HTM_GVL
+	th->gc_safe_point_reached = 0;
+#endif
+	return 0;
+    }
+ retry_acquiring_gvl:
+    if (spin_count <= 0)
+	spin_count = 1;
+#if defined(__370__)
+    local_acquired = 0;
+    while (cds((cds_t *)&local_acquired, (cds_t *)&vm->gvl.acquired, *(cds_t *)&new_value)) {
+	while (local_acquired = vm->gvl.acquired && --spin_count > 0)
+	    ;
+	if (spin_count <= 0)
+	    break;
+    }
+#elif defined(__GNUC__) || defined(__IBMC__)
+    while (__sync_val_compare_and_swap(&vm->gvl.acquired, 0, (unsigned long)th)) {
+	while (vm->gvl.acquired && --spin_count > 0)
+	    ;
+	if (spin_count <= 0)
+	    break;
+    }
+#else
+#error
+#endif
+    if (spin_count <= 0) {
+	native_mutex_lock(&vm->gvl.lock);
+	vm->gvl.waiting++;
+	/*fprintf(stderr, "thr %p increment vm->gvl.waiting to %d vm->gvl.acquired = %lx\n", th, vm->gvl.waiting, vm->gvl.acquired);*/
+	store_to_load_fence();
+	if (vm->gvl.acquired) {
+	    HTM_GVL_CHARGE_CYCLES_TO(gvl_wait_spin);
+	    native_cond_wait(&vm->gvl.cond, &vm->gvl.lock);
+	    HTM_GVL_CHARGE_CYCLES_TO(gvl_wait_sleep);
+	}
+	vm->gvl.waiting--;
+	/*fprintf(stderr, "thr %p decrement vm->gvl.waiting to %d\n", th, vm->gvl.waiting);*/
+	native_mutex_unlock(&vm->gvl.lock);
+	spin_count = rb_gvl_spin_max;
+	goto retry_acquiring_gvl;
+    } else {
+	HTM_GVL_CHARGE_CYCLES_TO_AND_START(gvl_wait_spin, gvl);
+    }
+    /*fprintf(stderr, "thr %p acquired vm->gvl.waiting\n", th);*/
+#ifdef HTM_GVL
+    th->gc_safe_point_reached = 0;
+#endif
+    return 1;
+}
+
+static void
+simple_gvl_release_2(rb_vm_t *vm, rb_thread_t *th)
+{
+    store_to_store_fence();
+    vm->gvl.acquired = 0;
+    store_to_load_fence();
+    /*fprintf(stderr, "thr %p look at vm->gvl.waiting as %d\n", th, vm->gvl.waiting);*/
+    if (vm->gvl.waiting > 0) {
+	native_mutex_lock(&vm->gvl.lock);
+	native_cond_signal(&vm->gvl.cond);
+	native_mutex_unlock(&vm->gvl.lock);
+    }
+}
+#endif
+
+#ifdef HTM_GVL
+#ifdef HTM_GVL_SUMMARY_STATS
+#define INCREMENT_STAT(field) th->htm_stats.field++;
+#else
+#define INCREMENT_STAT(field)
+#endif
+
+#define READ_FROM_COUNTER0(counter_addr)	\
+    ((*(uint32_t *)(counter_addr)) & 0xFF)
+
+#define WRITE_TO_COUNTER0(data, counter_addr)				\
+    do {								\
+	*(uint32_t *)(counter_addr) = (*(uint32_t *)(counter_addr) & ~0xFF) | (data); \
+    } while (0)
+
+#define READ_FROM_COUNTER1(counter_addr)	\
+    (*((uint32_t *)(counter_addr) + 1))
+
+#define WRITE_TO_COUNTER1(data, counter_addr)		\
+    do {						\
+	*((uint32_t *)(counter_addr) + 1) = (data);	\
+    } while (0)
+
+#define READ_FROM_COUNTER2(counter_addr)	\
+    ((*(uint32_t *)(counter_addr)) >> 8)
+
+#define WRITE_TO_COUNTER2(data, counter_addr)				\
+    do {								\
+	*(uint32_t *)(counter_addr) = (*(uint32_t *)(counter_addr) & 0xFF) | ((data) << 8); \
+    } while (0)
+
+#define GET_COUNTER0(counter02) ((counter02) & 0xFF)
+#define GET_COUNTER2(counter02) ((counter02) >> 8)
+
+#define READ_FROM_COUNTER02(counter_addr) \
+    (*(uint32_t *)(counter_addr))
+
+#define WRITE_TO_COUNTER02(counter0, counter2, counter_addr)		\
+    do {								\
+	*(uint32_t *)(counter_addr) = (counter2) << 8 | (counter0);	\
+    } while(0)
+
+#if defined(__370__)
+#define IS_PERSISTENT(reason, th) ((th)->diag.format != 1 || (reason) == 7 || (reason) == 8 || (11 <= (reason) && (reason) <= 13))
+#elif defined(__x86_64__)
+#define IS_PERSISTENT(reason, th) (! ((reason) & XABORT_RETRY))
+#elif defined(__PPC__) || defined(_ARCH_PPC)
+#define IS_PERSISTENT(reason, th) ((reason) & 0x0100000000000000ULL)
+#endif
+
+int64_t htm_counter_for_null;
+
+void
+htm_gvl_acquire_multi_threads(void *ptr, VALUE *cnt_addr)
+{
+    rb_thread_t *th = (rb_thread_t *)ptr;
+    rb_vm_t *vm = th->vm;
+    int persistent_retry_count;
+    int transient_retry_count;
+    int gvl_retry_count;
+    int first_retry;
+    int tbegin_result;
+    int64_t *counter_addr;
+    uint32_t next_interval = 0;
+    uint32_t wait_and_see_counter = 0;
+    uint32_t tx_size_recalc_counter = 0;
+
+    if (cnt_addr == NULL) {
+	counter_addr = &htm_counter_for_null;
+    } else {
+	rb_iseq_t *iseq = th->cfp->iseq;
+	counter_addr = &iseq->htm_counters[cnt_addr - iseq->iseq_encoded];
+    }
+
+    if (rb_htm_schedule_interval > 0) {
+	th->htm_schedule_counter = rb_htm_schedule_interval;
+#if 0
+    } else if (rb_htm_schedule_interval == -1) {
+	uint32_t counter02;
+
+	counter02 = READ_FROM_COUNTER02(counter_addr);
+	next_interval = GET_COUNTER0(counter02);
+	if (next_interval == 0) {
+	    next_interval = 1;
+	    WRITE_TO_COUNTER02(next_interval, 1, counter_addr);
+	} else if (next_interval < 255) {
+	    tx_size_recalc_counter = READ_FROM_COUNTER1(counter_addr);
+	    if (tx_size_recalc_counter <= rb_htm_tx_size_recalc_threshold) {
+		wait_and_see_counter = GET_COUNTER2(counter02) + 1;
+		if (wait_and_see_counter >= HTM_WAIT_AND_SEE_PERIOD) {
+		    next_interval = (int)ceil((double)next_interval * 4 / 3);
+		    if (next_interval > 255)
+			next_interval = 255;
+		    wait_and_see_counter = 0;
+		    WRITE_TO_COUNTER1(0, counter_addr);
+		}
+		WRITE_TO_COUNTER02(next_interval, wait_and_see_counter, counter_addr);
+	    }
+	}
+	th->htm_schedule_counter = next_interval;
+#endif
+    } else {
+	uint32_t counter02;
+
+	counter02 = READ_FROM_COUNTER02(counter_addr);
+	next_interval = GET_COUNTER0(counter02);
+	if (next_interval == 0) {
+	    next_interval = -rb_htm_schedule_interval;
+	    WRITE_TO_COUNTER02(next_interval, 1, counter_addr);
+	} else if (1 < next_interval) {
+	    wait_and_see_counter = GET_COUNTER2(counter02);
+	    if (wait_and_see_counter < HTM_WAIT_AND_SEE_PERIOD) {
+		WRITE_TO_COUNTER02(next_interval, wait_and_see_counter + 1, counter_addr);
+	    }
+	}
+	th->htm_schedule_counter = next_interval;
+    }
+
+    INCREMENT_STAT(tx_enter);
+    if (vm->gvl.acquired) {
+	if (htm_fall_back_gvl_acquire(vm, th, 0)) {
+	    INCREMENT_STAT(gvl_wait_before_tx_sleep);
+	    return;
+	} else {
+	    INCREMENT_STAT(gvl_wait_before_tx_spin);
+	}
+    }
+    /*fprintf(stderr, "%p tbegin\n", th);*/
+    persistent_retry_count = rb_htm_persistent_retry_max;
+    transient_retry_count = rb_htm_transient_retry_max;
+    gvl_retry_count = rb_htm_gvl_retry_max;
+    first_retry = 1;
+    HTM_GVL_CHARGE_CYCLES_TO_AND_START(between_tx, tx);
+
+ tx_retry:
+    INCREMENT_STAT(tx);
+    tbegin_result = tbegin(&th->diag);
+    /*tbegin_result = 3;*/
+    if (tbegin_result == 0) {
+	/* tbegin succeeded */
+	if (vm->gvl.acquired)
+	    tabort(256);
+    } else {
+	/* transaction failed */
+	uint64_t reason = th->diag.transactionAbortCode;
+	INCREMENT_STAT(abort);
+	HTM_GVL_CHANGE_CYCLE_CHARGING_TO(abort);
+	if (first_retry) {
+	    first_retry = 0;
+	    INCREMENT_STAT(first_abort);
+	    if (rb_htm_schedule_interval == -1 /* Adaptive transaction size enlargement */ &&
+		next_interval < 255 /* Can enlarge the size */ &&
+		tx_size_recalc_counter <= rb_htm_tx_size_recalc_threshold /* Stats collection period */) {
+		WRITE_TO_COUNTER1(tx_size_recalc_counter + 1, counter_addr);
+	    } else if (rb_htm_schedule_interval < 0 /* Adaptive transaction size*/ &&
+		1 < next_interval /* Can shorten the size */ &&
+		wait_and_see_counter < HTM_WAIT_AND_SEE_PERIOD /* Stats collection period */) {
+		tx_size_recalc_counter = READ_FROM_COUNTER1(counter_addr) + 1;
+		/*tx_size_recalc_counter = READ_FROM_COUNTER1(counter_addr) + (IS_PERSISTENT(reason, th) ? 7 : 1);*/
+		if (tx_size_recalc_counter > rb_htm_tx_size_recalc_threshold) {
+		    next_interval = next_interval * 3 / 4;
+		    WRITE_TO_COUNTER0(next_interval, counter_addr);
+		    /* Reinitialize the stats counters. */
+		    WRITE_TO_COUNTER1(0, counter_addr);
+		    WRITE_TO_COUNTER2(0, counter_addr);
+		} else {
+		    WRITE_TO_COUNTER1(tx_size_recalc_counter, counter_addr);
+		}
+	    }
+	}
+
+	if (vm->gvl.acquired) {
+	    if (--gvl_retry_count > 0) {
+		if (htm_fall_back_gvl_acquire(vm, th, 0)) {
+		    INCREMENT_STAT(gvl_wait_and_retry_sleep);
+		    return;
+		} else {
+		    INCREMENT_STAT(gvl_wait_and_retry_spin);
+		}
+		HTM_GVL_CHARGE_CYCLES_TO_AND_START(abort, tx);
+		goto tx_retry;
+	    }
+	    INCREMENT_STAT(gvl_acquired);
+	    htm_fall_back_gvl_acquire(vm, th, 1);
+	} else {
+#ifdef HTM_GVL_SUMMARY_STATS
+#if defined(__370__)
+	    if (th->diag.format != 1) {
+		th->htm_stats.abort_reason_code[0][tbegin_result - 1]++;
+	    } else if (reason <= 16) {
+		th->htm_stats.abort_reason_code[reason][tbegin_result - 1]++;
+	    } else if (reason == 255) {
+		th->htm_stats.abort_reason_code[17][tbegin_result - 1]++;
+	    } else {
+		th->htm_stats.abort_reason_code[18][tbegin_result - 1]++;
+	    }
+#elif defined(__x86_64__)
+#define THCTR th->htm_stats.abort_reason_counters
+	    THCTR.XABORT                    += (reason & XABORT_EXPLICIT) ? 1L : 0L;
+	    THCTR.TRANSIENT                 += (reason & XABORT_RETRY) ? 1L : 0L;
+	    THCTR.MEMADDR_CONFLICT          += (reason & XABORT_CONFLICT) ? 1L : 0L;
+	    THCTR.BUFFER_OVERFLOW           += (reason & XABORT_CAPACITY) ? 1L : 0L;
+	    THCTR.HIT_DEBUG_BREAKPOINT      += (reason & XABORT_DEBUG) ? 1L : 0L;
+	    THCTR.DURING_NESTED_TRANSACTION += (reason & XABORT_NESTED) ? 1L : 0L;
+	    THCTR.OTHER                     += (reason & (XABORT_EXPLICIT | XABORT_RETRY | XABORT_CONFLICT | XABORT_CAPACITY | XABORT_DEBUG | XABORT_NESTED)) ? 0L : 1L;
+#elif defined(__PPC__) || defined(_ARCH_PPC)
+#define THCTR th->htm_stats.abort_reason_counters
+#define PPC_BFIELD(x) ((0x1ULL) << (63 - x))
+	    THCTR.Failure_Persistent                += (reason & PPC_BFIELD( 7)) ? 1 : 0;
+	    THCTR.Disallowed                        += (reason & PPC_BFIELD( 8)) ? 1 : 0;
+	    THCTR.Nesting_Overflow                  += (reason & PPC_BFIELD( 9)) ? 1 : 0;
+	    THCTR.Footprint_Overflow                += (reason & PPC_BFIELD(10)) ? 1 : 0;
+	    THCTR.Self_Induced_Conflict             += (reason & PPC_BFIELD(11)) ? 1 : 0;
+	    THCTR.Non_Transactional_Conflict        += (reason & PPC_BFIELD(12)) ? 1 : 0;
+	    THCTR.Transaction_Conflict              += (reason & PPC_BFIELD(13)) ? 1 : 0;
+	    THCTR.Translation_Invalidation_Conflict += (reason & PPC_BFIELD(14)) ? 1 : 0;
+	    THCTR.Implementation_Specific           += (reason & PPC_BFIELD(15)) ? 1 : 0;
+	    THCTR.Instruction_Fetch_Conflict        += (reason & PPC_BFIELD(16)) ? 1 : 0;
+	    THCTR.Tabort_Treclaim                   += (reason & PPC_BFIELD(31)) ? 1 : 0;
+	    THCTR.Other                             += (reason & (PPC_BFIELD(7) | PPC_BFIELD(8) | PPC_BFIELD(9) | PPC_BFIELD(10) | PPC_BFIELD(11) | PPC_BFIELD(12) | PPC_BFIELD(13) | PPC_BFIELD(14) | PPC_BFIELD(15) | PPC_BFIELD(16) | PPC_BFIELD(31))) ? 0 : 1;
+#endif
+#endif
+	    /*if (tbegin_result == 3) {*/
+	    if (IS_PERSISTENT(reason, th)) {
+		if (--persistent_retry_count > 0) {
+		    INCREMENT_STAT(persistent_abort_retry);
+		    HTM_GVL_CHARGE_CYCLES_TO_AND_START(abort, tx);
+		    goto tx_retry;
+		}
+		/* persistent failure */
+		INCREMENT_STAT(gvl_persistent_abort);
+		htm_fall_back_gvl_acquire(vm, th, 1);
+	    } else
+	      {
+		if (--transient_retry_count > 0) {
+		    INCREMENT_STAT(transient_abort_retry);
+		    HTM_GVL_CHARGE_CYCLES_TO_AND_START(abort, tx);
+		    goto tx_retry;
+		}
+		INCREMENT_STAT(gvl_transient_abort);
+		htm_fall_back_gvl_acquire(vm, th, 1);
+	    }
+	}
+    }
+}
+#endif
+
 static void
 gvl_acquire(rb_vm_t *vm, rb_thread_t *th)
 {
+#if defined(USE_SIMPLE_GVL_2) && ! defined(HTM_GVL)
+    htm_fall_back_gvl_acquire(vm, th, 1);
+#else
+#if defined(HTM_GVL)
+    if (vm->use_gvl) {
+#endif
     native_mutex_lock(&vm->gvl.lock);
     gvl_acquire_common(vm);
     native_mutex_unlock(&vm->gvl.lock);
+#if defined(HTM_GVL)
+    } else {
+	if (rb_thread_alone()) {
+	    htm_fall_back_gvl_acquire(vm, th, 1);
+	} else {
+	    htm_gvl_acquire_multi_threads(th, NULL);
+	}
+    }
+#endif
+#endif
 }
 
 static void
@@ -91,17 +473,60 @@
 	native_cond_signal(&vm->gvl.cond);
 }
 
+#ifdef HTM_GVL
+void
+gvl_release(void *vm_ptr, void *th_ptr)
+#else
 static void
 gvl_release(rb_vm_t *vm)
+#endif
 {
+#if defined(USE_SIMPLE_GVL_2) && ! defined(HTM_GVL)
+    simple_gvl_release_2(vm, GET_THREAD());
+#else
+#if defined(HTM_GVL)
+    rb_vm_t *vm = (rb_vm_t *)vm_ptr;
+    if (vm->use_gvl) {
+#endif
     native_mutex_lock(&vm->gvl.lock);
     gvl_release_common(vm);
     native_mutex_unlock(&vm->gvl.lock);
+#if defined(HTM_GVL)
+    } else {
+	rb_thread_t *th = (rb_thread_t *)th_ptr;
+
+	if (vm->gvl.acquired) {
+#if defined (USE_SIMPLE_GVL_2)
+	    simple_gvl_release_2(vm, th);
+#else
+	    native_mutex_lock(&vm->gvl.lock);
+	    vm->gvl.acquired = 0;
+	    native_cond_signal(&vm->gvl.cond);
+	    /*native_cond_broadcast(&vm->gvl.cond);*/
+	    native_mutex_unlock(&vm->gvl.lock);
+#endif
+	    HTM_GVL_CHARGE_CYCLES_TO_AND_START(gvl, between_tx);
+	} else {
+	    tend();
+	    HTM_GVL_CHARGE_CYCLES_TO_AND_START(tx, between_tx);
+	    /*th->diag.reserved2 = 0;*/
+	}
+    }
+#endif /* HTM_GVL */
+#endif
 }
 
 static void
 gvl_yield(rb_vm_t *vm, rb_thread_t *th)
 {
+#if defined(USE_SIMPLE_GVL_2) && ! defined(HTM_GVL)
+    simple_gvl_release_2(vm, th);
+    sched_yield();
+    htm_fall_back_gvl_acquire(vm, th, 1);
+#else
+#if defined(HTM_GVL)
+    if (vm->use_gvl) {
+#endif
     native_mutex_lock(&vm->gvl.lock);
 
     gvl_release_common(vm);
@@ -131,6 +556,13 @@
   acquire:
     gvl_acquire_common(vm);
     native_mutex_unlock(&vm->gvl.lock);
+#if defined(HTM_GVL)
+    } else {
+	gvl_release(vm, th);
+	gvl_acquire(vm, th);
+    }
+#endif /* HTM_GVL */
+#endif
 }
 
 static void
@@ -416,11 +848,19 @@
     /* null */
 }
 
+#if RUBY_VM_THREAD_MODEL == 3
+rb_thread_t *
+ruby_thread_from_native(void)
+{
+    return pthread_getspecific(ruby_native_thread_key);
+}
+#else
 static rb_thread_t *
 ruby_thread_from_native(void)
 {
     return pthread_getspecific(ruby_native_thread_key);
 }
+#endif
 
 static int
 ruby_thread_set_native(rb_thread_t *th)
@@ -433,7 +873,11 @@
 void
 Init_native_thread(void)
 {
+#if RUBY_VM_THREAD_MODEL == 3
+    rb_thread_t *th = ruby_current_thread;
+#else
     rb_thread_t *th = GET_THREAD();
+#endif
 
     pthread_key_create(&ruby_native_thread_key, NULL);
     th->thread_id = pthread_self();
@@ -653,6 +1097,7 @@
 #endif
 	native_thread_init(th);
 	/* run */
+	HTM_GVL_START_CYCLES();
 #if defined USE_NATIVE_THREAD_INIT
 	thread_start_func_2(th, th->machine_stack_start, rb_ia64_bsp());
 #else
@@ -905,10 +1350,12 @@
 	    thread_debug("native_sleep: interrupted before sleep\n");
 	}
 	else {
+	    HTM_GVL_CHARGE_CYCLES_TO_SAVED_TARGET();
 	    if (!timeout_tv)
 		native_cond_wait(cond, lock);
 	    else
 		native_cond_timedwait(cond, lock, &timeout);
+	    HTM_GVL_CHARGE_CYCLES_TO_AND_START(native_sleep, between_tx);
 	}
 	th->unblock.func = 0;
 	th->unblock.arg = 0;
@@ -1147,7 +1594,11 @@
 	FD_ZERO(&rfds);
 	FD_SET(timer_thread_pipe[0], &rfds);
 
-	if (gvl->waiting > 0 || need_polling) {
+	if (gvl->waiting > 0 || need_polling
+#ifdef USE_SIMPLE_GVL_2
+	    || 1
+#endif
+	    ) {
 	    timeout.tv_sec = 0;
 	    timeout.tv_usec = TIME_QUANTUM_USEC;
 
diff -Naur ruby-1.9.3-p547.original/thread_pthread.h ruby-1.9.3-p547.htm/thread_pthread.h
--- ruby-1.9.3-p547.original/thread_pthread.h	2011-06-27 21:59:08.000000000 +0900
+++ ruby-1.9.3-p547.htm/thread_pthread.h	2014-09-12 06:37:35.905002000 +0900
@@ -5,6 +5,7 @@
   $Author: kosaki $
 
   Copyright (C) 2004-2007 Koichi Sasada
+  Copyright (c) IBM Corp. 2014.
 
 **********************************************************************/
 
@@ -34,7 +35,11 @@
 
 typedef struct rb_global_vm_lock_struct {
     /* fast path */
+#if defined(USE_SIMPLE_GVL_2)
+    volatile unsigned long acquired;
+#else
     unsigned long acquired;
+#endif
     pthread_mutex_t lock;
 
     /* slow path */
diff -Naur ruby-1.9.3-p547.original/tool/instruction.rb ruby-1.9.3-p547.htm/tool/instruction.rb
--- ruby-1.9.3-p547.original/tool/instruction.rb	2011-05-15 20:55:52.000000000 +0900
+++ ruby-1.9.3-p547.htm/tool/instruction.rb	2014-09-12 06:37:35.905002000 +0900
@@ -798,6 +798,18 @@
     end
 
     def make_header_pc insn
+      if insn.name == "send" ||
+          insn.name == "getinstancevariable" ||
+          insn.name == "getclassvariable" ||
+          insn.name == "send" ||
+          insn.name == "getlocal" ||
+          insn.name == "opt_plus" ||
+          insn.name == "opt_minus" ||
+          insn.name == "opt_mult" ||
+          insn.name == "opt_aref"
+      then
+        commit "#if defined(HTM_GVL)\n  RUBY_VM_HTM_CHECK_SCHED(&GET_OPERAND(0));\n#endif"
+      end
       commit  "  ADD_PC(1+#{@opn});"
       commit  "  PREFETCH(GET_PC());"
     end
